Package org.apache.commons.collections4.map

# Class LazySortedMap<K,V>

java.lang.Object
org.apache.commons.collections4.map.AbstractIterableMap<K,V>
org.apache.commons.collections4.map.AbstractMapDecorator<K,V>
org.apache.commons.collections4.map.LazyMap<K,V>
org.apache.commons.collections4.map.LazySortedMap<K,V>

Type Parameters:
  `K` - the type of the keys in this map
  `V` - the type of the values in this map

All Implemented Interfaces:
  `Serializable`, `Map<K,V>`, `SortedMap<K,V>`, `Get<K,V>`, `IterableGet<K,V>`, `IterableMap<K,V>`, `Put<K,V>`

public class LazySortedMap<K,V> extends LazyMap<K,V> implements SortedMap<K,V>
Decorates another `SortedMap` to create objects in the map on demand.

When the `LazyMap.get(Object)` method is called with a key that does not exist in the map, the factory is used to create the object. The created object will be added to the map using the requested key.

For instance:

     Factory<Date> factory = new Factory<Date>() {
         public Date create() {
             return new Date();
         }
     }
     SortedMap<String, Date> lazy =
         LazySortedMap.lazySortedMap(new HashMap<String, Date>(), factory);
     Date date = lazy.get("NOW");

After the above code is executed, `date` will refer to a new `Date` instance. Furthermore, that `Date` instance is mapped to the "NOW" key in the map.

Note that LazySortedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedSortedMap(java.util.SortedMap<K, V>)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

This class is Serializable from Commons Collections 3.1.

Since:
  3.0
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K extends Object,V extends Object>`

- ## Field Summary

  ### Fields inherited from class org.apache.commons.collections4.map.LazyMap

  `factory`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `LazySortedMap(SortedMap<K,V> map, Factory<? extends V> factory)`
  Constructor that wraps (not copies).
  `protected`
  `LazySortedMap(SortedMap<K,V> map, Transformer<? super K,? extends V> factory)`
  Constructor that wraps (not copies).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Comparator<? super K>`
  `comparator()`
  `K`
  `firstKey()`
  `protected SortedMap<K,V>`
  `getSortedMap()`
  Gets the map being decorated.
  `SortedMap<K,V>`
  `headMap(K toKey)`
  `K`
  `lastKey()`
  `static <K, V> LazySortedMap<K,V>`
  `lazySortedMap(SortedMap<K,V> map, Factory<? extends V> factory)`
  Factory method to create a lazily instantiated sorted map.
  `static <K, V> LazySortedMap<K,V>`
  `lazySortedMap(SortedMap<K,V> map, Transformer<? super K,? extends V> factory)`
  Factory method to create a lazily instantiated sorted map.
  `SortedMap<K,V>`
  `subMap(K fromKey, K toKey)`
  `SortedMap<K,V>`
  `tailMap(K fromKey)`

  ### Methods inherited from class org.apache.commons.collections4.map.LazyMap

  `get, lazyMap, lazyMap`

  ### Methods inherited from class org.apache.commons.collections4.map.AbstractMapDecorator

  `clear, containsKey, containsValue, decorated, entrySet, equals, hashCode, isEmpty, keySet, put, putAll, remove, size, toString, values`

  ### Methods inherited from class org.apache.commons.collections4.map.AbstractIterableMap

  `mapIterator`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Map

  `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, equals, forEach, get, getOrDefault, hashCode, isEmpty, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size`

  ### Methods inherited from interface java.util.SortedMap

  `entrySet, keySet, values`

- ## Constructor Details

  - ### LazySortedMap

    protected LazySortedMap(SortedMap<K,V> map, Factory<? extends V> factory)
    Constructor that wraps (not copies).
    Parameters:
      `map` - the map to decorate, must not be null
      `factory` - the factory to use, must not be null
    Throws:
      `NullPointerException` - if map or factory is null

  - ### LazySortedMap

    protected LazySortedMap(SortedMap<K,V> map, Transformer<? super K,? extends V> factory)
    Constructor that wraps (not copies).
    Parameters:
      `map` - the map to decorate, must not be null
      `factory` - the factory to use, must not be null
    Throws:
      `NullPointerException` - if map or factory is null

- ## Method Details

  - ### lazySortedMap

    public static <K, V> LazySortedMap<K,V> lazySortedMap(SortedMap<K,V> map, Factory<? extends V> factory)
    Factory method to create a lazily instantiated sorted map.
    Type Parameters:
      `K` - the key type
      `V` - the value type
    Parameters:
      `map` - the map to decorate, must not be null
      `factory` - the factory to use, must not be null
    Returns:
      a new lazy sorted map
    Throws:
      `NullPointerException` - if map or factory is null
    Since:
      4.0

  - ### lazySortedMap

    public static <K, V> LazySortedMap<K,V> lazySortedMap(SortedMap<K,V> map, Transformer<? super K,? extends V> factory)
    Factory method to create a lazily instantiated sorted map.
    Type Parameters:
      `K` - the key type
      `V` - the value type
    Parameters:
      `map` - the map to decorate, must not be null
      `factory` - the factory to use, must not be null
    Returns:
      a new lazy sorted map
    Throws:
      `NullPointerException` - if map or factory is null
    Since:
      4.0

  - ### comparator

    public Comparator<? super K> comparator()
    Specified by:
      `comparator` in interface `SortedMap<K,V>`

  - ### firstKey

    public K firstKey()
    Specified by:
      `firstKey` in interface `SortedMap<K,V>`

  - ### getSortedMap

    protected SortedMap<K,V> getSortedMap()
    Gets the map being decorated.
    Returns:
      the decorated map

  - ### headMap

    public SortedMap<K,V> headMap(K toKey)
    Specified by:
      `headMap` in interface `SortedMap<K,V>`

  - ### lastKey

    public K lastKey()
    Specified by:
      `lastKey` in interface `SortedMap<K,V>`

  - ### subMap

    public SortedMap<K,V> subMap(K fromKey, K toKey)
    Specified by:
      `subMap` in interface `SortedMap<K,V>`

  - ### tailMap

    public SortedMap<K,V> tailMap(K fromKey)
    Specified by:
      `tailMap` in interface `SortedMap<K,V>`